;	SCCSID = @(#)msinit.asm 1.2 85/07/23
; TITLE MSINIT.ASM -- MS-DOS INITIALIZATION CODE
; AN000 version 4.0 Jan. 1988
; AN007 PTM 3957 - fake version for IBMCACHE.COM
; AN008 PTM 4070 - fake version for MS WINDOWS
[list -]
%include "sysvar.mac"
%include "doscntry.mac"
%include "fastopen.mac"
%include "lmacros3.mac"
%include "entrysw.mac"
[list +]

addsection BIOCODE, class=BIOCODE
extern i20, i21, i25, i26, i27, i2F, call5, i23, i24, entry_iret

	I_need	DMAAdd,DWORD		; current dma address
	I_need	DPBHead,DWORD		; long pointer to DPB chain
	I_need	SFT_Addr,DWORD		; pointer to open file list
	I_need	NumIO,BYTE		; number of physical drives
	I_need	BuffHead,DWORD		; pointer to buffer chain
	I_need	EndMem,WORD		; first unavailable address in memory
	I_need	CurrentPDB,WORD 	; current process ID
	I_need	CreatePDB,BYTE		; TRUE => create a new PDB
	I_need	Arena_Head,WORD 	; paragraph address of head of arena
	I_need	sfTabl,BYTE		; internal file table
	I_need	SysInitVar,BYTE 	; label for internal structures
	I_need	NulDev,DWORD		; long pointer to device chain
	I_need	BCon,DWORD		; pointer to console device
	I_need	BClock,DWORD		; pointer to clock device
	I_need	CallUnit,BYTE		; unit field in dd packet
	I_need	CallBPB,DWORD		; returned BPB from DD
	I_need	Maxsec,WORD
	I_need	Dskchret,BYTE
	I_need	Devcall,BYTE
	i_need	Header,BYTE
	I_need	JShare,DWORD
	I_need	COUNTRY_CDPG,BYTE	 ; country info table, DOS 3.3
	I_need	SysInitTable,BYTE	 ; sys init table for SYSINIT
	I_need	FastOpenTable,BYTE	 ; table for FASTOPEN
	I_need	FETCHI_TAG,WORD 	 ; TAG CHECK
	I_need	Special_Entries,WORD	 ; address of special entries ;AN007;
	I_need	IFS_DOS_CALL,DWORD	 ; IFS IBMDOS CALL entry      ;AN000;
	I_need	HASHINITVAR,WORD	 ; hash table variables       ;AN000;
	I_need	Packet_Temp,WORD	 ; used for initial Hash table;AN000;
	I_need	BUF_HASH_PTR,DWORD	 ; used for initial Hash table;AN000;
	I_need	SWAP_ALWAYS_AREA,DWORD	 ; swap always area addr    ;AN000;
	I_need	SWAP_ALWAYS_AREA_LEN,WORD; swap always area length  ;AN000;
	I_need	SWAP_IN_DOS,DWORD	 ; swap in dos area	    ;AN000;
	I_need	SWAP_IN_DOS_LEN,WORD	 ; swap in dos area length  ;AN000;
	I_need	SWAP_AREA_LEN,WORD	 ; swap area length	    ;AN000;
	I_need	SWAP_START,BYTE 	 ; swap start addr	    ;AN000;
	I_need	SWAP_ALWAYS,BYTE	 ; swap always addr	    ;AN000;
	I_need	Hash_Temp,WORD		 ; temporary Hash table     ;AN000;

	i_need	CallDevAd,DWORD

section DOSCODECODE
	Extrn	IRETT:NEAR,INT2F:NEAR,CALL_ENTRY:NEAR,QUIT:NEAR,IFS_DOSCALL:FAR
	Extrn	COMMAND:NEAR,ABSDRD:NEAR,ABSDWRT:NEAR
; (no prior section) ; DOSCODECODE		ENDS

section DATA
	; ORG	0			; reset to beginning of data segment

%ifndef DONOBITS

Public MSINI001S,MSINI001E
MSINI001S label byte
MSINI001E label byte

ASSUME	CS:DOSGROUP,SS:NOTHING


section SYSINITSEG PUBLIC class=INIT align=16
section SYSINITTRAIL PUBLIC class=INIT

group SYSINITGROUP SYSINITSEG SYSINITTRAIL

extern doscode_retf
extern dosdata_to_doscode

%imacro neartransfer 1.nolist
	extern %1
	call transfer_sysinitseg_to_doscode
	jmp strict short %%skip
	dw %1
%%skip:
%endmacro

transfer_sysinitseg_to_doscode:		; near call ip: in_ip_out_cs
	push ax				; in_ax_out_ip
	mov ax, doscode_retf
	push ax				; out_retf
	push ax				; out_destination + 2
	push ax				; out_destination + 0
	lframe 0
	lpar word, in_ip_out_cs
	lpar word, in_ax_out_ip
	lpar word, out_retf
	lpar dword, out_destination
	lenter
	push ds
	push si
	mov si, cs			; si = cs
	xchg si, word [bp + ?in_ip_out_cs]
					; set cs, get ip
	push si				; preserve ip for later
	lodsw				; skip jmp short
	cs lodsw			; get destination
	mov word [bp + ?out_destination + 0], ax
					; set destination
	call getdosdata
	mov ds, ax
	mov ax, word [dosdata_to_doscode]
					; ax => DOSCODE
	mov word [bp + ?out_destination + 2], ax
					; => DOSCODE
	pop ax
	xchg ax, word [bp + ?in_ax_out_ip]
					; ax = original ax, set out ip
	pop si
	pop ds
	lleave
	retf


getdosdata:
	push ds
	mov ax, 0
	mov ds, ax			; ds => IVT
	mov ax, [31h * 4 + 2]		; ds => DOSDATA
	pop ds
	retn


MOVDPB:
	DOSAssume   CS,<DS,ES>,"MovDPB"
	CLD
sft_addr equ SFT_Addr	; NASM port label
	MOV	WORD PTR [sft_addr+2], ds
NUMIO equ NumIO	; NASM port label
	MOV	CL,[NUMIO]	; Number of DPBs
	XOR	CH,CH
DPBHEAD equ DPBHead	; NASM port label
	mov si, -1
	jcxz @F
	lds	SI, [DPBHEAD]; Address of first DPB
	push si
SETFINDPB:
	MOV	byte [SI + dpb_first_access],-1	 ; Never accessed before
	ADD	SI, DPBSIZ	; Point to next DPB
	LOOP	SETFINDPB
	pop si
@@:
	mov [es:DPBHEAD], si	; Address of first DPB


DOSGroup equ DOSGROUP	; NASM port equate
	ASSUME	ES:DOSGroup

sftabl equ sfTabl	; NASM port label

	retn


section DATA

%macro replayrecorded 2-*.nolist
 %rep (%0 - 2) / 2
  %rotate 2
  %assign %%offset %1
  %assign %%value %2
  %if ($ - MSINI001S) < %%offset
	org %%offset
  %endif
  %if ($ - MSINI001S) == %%offset
	db %%value
  %endif
 %endrep
%endmacro

	replayrecorded RECORDED

	org (MSDAT001e - MSDAT001S)
%else	; DONOBITS
	org (MSDAT001e - MSDAT001S), db ?
%endif	; DONOBITS

; (no prior section) ; DATA	ENDS

; the next segment defines a new class that MUST appear last in the link map.
; This defines several important locations for the initialization process that
; must be the first available locations of free memory.

section LAST

%ifndef DONOBITS

entry DOSINIT
	retf

	align 2, nop

	PUBLIC	SYSBUF
	PUBLIC	MEMSTRT

SYSBUF	LABEL	WORD
ASSUME	CS:DOSGROUP,DS:NOTHING,ES:NOTHING,SS:NOTHING


section SYSINITTRAIL

%ifndef DOPLACEHOLDER

		; INP:	ax => DOS module (DOS data segment)
		;	bx => where to create PSP
		;	dx => behind usable memory (at EBDA or UMA)
		;	ss:sp -> init stack
		;	ds:si -> CON device
		;		(and subsequent device chain in msbio)
	entry	NEARDOSINIT
	CLI
	CLD
	mov es, ax		; es => DOSDATA
	MOV	[es:CurrentPDB], bx
	MOV	[es:ENDMEM],DX
NULDEV equ NulDev	; NASM port label
	MOV	WORD PTR [es:NULDEV+2],DS
	MOV	WORD PTR [es:NULDEV],SI   ; DS:SI Points to CONSOLE Device

	push ds
	push si
			; Need Crit vector inited to use DEVIOCALL
	XOR	AX,AX
	MOV	DS,AX
	mov word [31h * 4 + 2], es	; RI31S => DOSDATA
	MOV	word [addr_int_IBM], entry_iret + DOSENTRYADJUSTOFFSET
	MOV	word [addr_int_IBM+2], BIOCODE - DOSENTRYADJUSTSEGMENT

	push es
	pop ds

	MOV	BP,OFFSET SYSBUF wrt DOSGROUP
	MOV	[Special_Entries],BP ;MS.;AN007 save starting address of Special entries
	MOV	SI,OFFSET Version_Fake_Table wrt DOSGROUP	;MS.;AN007
	MOV	DX,SI		     ;MS.;AN007
	XOR	AH,AH		     ;MS.;AN007
NextEntry:			     ;MS.;AN007
	LODSB			     ;MS.;AN007  get name length
	test	AL,AL		     ;MS.;AN007  end of list
	JZ	endlist 	     ;MS.;AN007  yes
	ADD	SI,AX		     ;MS.;AN007  position to
	ADD	SI,3		     ;MS.;AN007  next entry
	JMP	NextEntry	     ;MS.;AN007
endlist:			     ;MS.;AN007
	SUB	SI,DX		     ;MS.;AN007
	ADD	BP,SI		     ;MS.;AN007

	mov cx, si
	mov si, dx
	mov di, SYSBUF wrt DOSGROUP
	rep movsb

	ADD	BP,15		; True start of free space (round up to segment)
	RCR	BP,1
	MOV	CL,3
	SHR	BP,CL		; Number of segments for DOS resources
;;;;;;	MOV	[IBMDOS_SIZE],BP ;MS. save it for information
	MOV	DX, es
	ADD	DX,BP		; First free segment
	MOV	BX,0FH
	MOV	CX,[ENDMEM]

	%IF	HIGHMEM
	SUB	CX,BP
	MOV	BP,CX		; Segment of DOS
	MOV	DX, es		; Program segment
	%ENDIF

	%IFN HIGHMEM
	MOV	BP, es
	%ENDIF

; BP has segment of DOS (whether to load high or run in place)
; DX has program segment (whether after DOS or overlaying DOS)
; CX has size of memory in paragraphs (reduced by DOS size if HIGHMEM)
	MOV	[ENDMEM],CX
	MOV	ES,BP
ASSUME	ES:DOSGROUP

	%IF	HIGHMEM
	XOR	SI,SI
	MOV	DI,SI
	MOV	CX,OFFSET SYSBUF wrt DOSGROUP  ;# bytes to move
	SHR	CX,1		;# words to move (carry set if odd)
	REP MOVSW		; Move DOS to high memory
	JNC	NOTODD
	MOVSB
NOTODD:
	%ENDIF

	push es

extern doscode_start
extern afterdoslabel

	mov ax, doscode_start wrt DOSSTART
	mov cl, 4
	shr ax, cl		; delta DOSCODE image - DOSDATA image
	mov cx, es
	add cx, ax
	mov ds, cx		; => DOSCODE image
	xor si, si		; -> DOSCODE image

	mov es, dx
	xor di, di		; -> DOSCODE destination

	mov cx, afterdoslabel wrt DOSCODETABLE
	shr cx, 1		; = amount words in DOSCODE image
	mov ax, cx
	rep movsw		; move DOSCODE to next position

	pop es
	mov word [es:dosdata_to_doscode], dx
				; => DOSCODE (!= DOSDATA)
	mov cl, 3
	shr ax, cl		; = how many paragraphs in DOSCODE
	add dx, ax		; => free memory

	pop si
	pop ds

	push dx
	push bp

	CALL	CHARINIT
	PUSH	SI			; Save pointer to header
		; es => DOSDATA
	ASSUME	ES:DOSGROUP
	MOV	DI,OFFSET sftabl + SFTable wrt DOSGROUP   ; Point to sft 0
	MOV	AX,3
	STOSW		; Refcount
	DEC	ax
	errnz	sf_mode-(sf_ref_count+2)
	STOSW		; Access rd/wr, compatibility
	XOR	AL,AL
	errnz	sf_attr-(sf_mode+2)
	STOSB		; attribute
	MOV	AL,devid_device_EOF | devid_device | ISCIN | ISCOUT
	errnz	sf_flags-(sf_attr+1)
	STOSW		; Flags
	MOV	AX,SI
	errnz	sf_devptr-(sf_flags+2)
	STOSW			; Device pointer in devptr
	MOV	AX,DS
	STOSW
	XOR	AX,AX
	errnz	sf_firclus-(sf_devptr+4)
	STOSW			; firclus
	errnz	sf_time-(sf_firclus+2)
	STOSW			; time
	errnz	sf_date-(sf_time+2)
	STOSW			; date
	DEC	AX
	errnz	sf_size-(sf_date+2)
	STOSW			; size
	STOSW
	INC	AX
	errnz	sf_position-(sf_size+4)
	STOSW			; position
	STOSW
	ADD	DI,sf_name - sf_cluspos ;Point at name
	ADD	SI,SDEVNAME		; Point to name
	MOV	CX,4
	REP	MOVSW	; Name
	MOV	CL,3
	MOV	AL," "
	REP	STOSB	; Extension
	POP	SI	; Get back pointer to header
	OR	BYTE PTR [SI + SDEVATT],ISCIN | ISCOUT
BCON equ BCon	; NASM port label
	MOV	WORD PTR [es:BCON],SI
	MOV	WORD PTR [es:BCON+2],DS

	pop bp
	pop dx

DSKCHRET equ Dskchret	; NASM port label
	MOV	WORD PTR [ES:DSKCHRET+3],ES
	XOR	AX,AX
	MOV	DS,AX
	MOV	ES,AX
ASSUME	DS:NOTHING,ES:NOTHING
	MOV	DI,INTBASE+2
	MOV	AX,BP		; Final DOS segment to AX

	EXTRN	DIVOV:near
	MOV	WORD PTR [0],OFFSET DIVOV wrt DOSGROUP	; Set default divide trap address
	MOV	[2],AX		; => DOSDATA

; Set vectors 20-28 and 2A-3F to point to IRET.
	push ax

	mov ax, BIOCODE - DOSENTRYADJUSTSEGMENT
	MOV	CX,17
	REP	STOSW		; Set 9 segments
				;   Sets segs for INTs 20H-28H
	ADD	DI,6		; Skip INT 29H vector (FAST CON) as it may
				;   already be set.
	MOV	cl, 43
	REP	STOSW		; Set 22 segments
				;   Sets segs for vectors 2AH-3FH
	pop word [31h * 4 + 2]	; RI31S => DOSDATA

	MOV	DI,INTBASE
	MOV	AX, entry_iret + DOSENTRYADJUSTOFFSET
	MOV	cl, 9		; Set 9 offsets (skip 2 between each)
				;   Sets offsets for INTs 20H-28H

ISET1:
	STOSW			; offset
	scasw			; di += 2
	LOOP	ISET1

	scasw			; di += 2
	scasw			; di += 2
				; Skip vector 29H

	MOV	cl, 22		; Set 22 offsets (skip 2 between each)
				;   Sets offsets for INTs 2AH-3FH

ISET2:
	STOSW
	scasw			; di += 2
	LOOP	ISET2

	MOV	AX,BP		; Final DOS segment to AX

%IF installed
; the following two are in the Code segment, thus the CS
; overrides
	MOV	WORD PTR [02FH * 4], i2F + DOSENTRYADJUSTOFFSET
%ENDIF

; Set up entry point call at vectors 30-31H
	MOV	BYTE PTR [ENTRYPOINT],mi_Long_JMP
	MOV	WORD PTR [ENTRYPOINT+1], call5 + DOSENTRYADJUSTOFFSET
	MOV	WORD PTR [ENTRYPOINT+3], BIOCODE - DOSENTRYADJUSTSEGMENT

	%IF	ALTVECT
	MOV	DI,ALTBASE+2
	MOV	CX,15
	REP	STOSW		; Set 8 segments (skip 2 between each)
	%ENDIF

		; all interrupt handler entrypoints
		;  => BIOCODE - DOSENTRYADJUSTSEGMENT
	MOV	WORD PTR [addr_int_abort], i20 + DOSENTRYADJUSTOFFSET
	MOV	WORD PTR [addr_int_command], i21 + DOSENTRYADJUSTOFFSET
	MOV	WORD PTR [addr_int_terminate],100H
	MOV	WORD PTR [addr_int_terminate+2],DX
	MOV	WORD PTR [23h * 4], i23 + DOSENTRYADJUSTOFFSET
	MOV	WORD PTR [24h * 4], i24 + DOSENTRYADJUSTOFFSET
	MOV	WORD PTR [addr_int_disk_read], i25 + DOSENTRYADJUSTOFFSET
	MOV	WORD PTR [addr_int_disk_write], i26 + DOSENTRYADJUSTOFFSET
	MOV	WORD PTR [addr_int_keep_process], i27 + DOSENTRYADJUSTOFFSET

	call getdosdata
	mov ds, ax
	mov es, ax
ASSUME	DS:DOSGROUP,ES:DOSGROUP

	mov ax, dx
arena_head equ Arena_Head	; NASM port label
	MOV	[ES:arena_head],AX

	push ds
	MOV	DS,AX
	MOV	byte [arena_signature],arena_signature_end
	MOV	word [arena_owner],arena_owner_system
ENDMEM equ EndMem	; NASM port label
	SUB	AX,[ES:ENDMEM]
	not ax			; like neg ax, dec ax
	MOV	[arena_size],AX
	pop ds

	MOV	AX,[ENDMEM]
	MOV	dx, [CurrentPDB]

	neartransfer	SETMEM	; Basic Header
				; SETMEM works with ss != DOSDATA
	mov word [ES:PDB_Parent_PID], es
				; set parent to itself (better than uninit)
ASSUME	DS:NOTHING,ES:NOTHING
	call getdosdata
	mov ds, ax
ASSUME	DS:DOSGROUP
	MOV	DI,PDB_JFN_Table
	XOR	AX,AX
	STOSW
	STOSB			; 0,1 and 2 are CON device
	MOV	AL,0FFH
	MOV	CX,FilPerProc - 3
	REP	STOSB		; Rest are unused
	PUSH	ds
	POP	ES
ASSUME	ES:DOSGROUP
	MOV	WORD PTR [sft_addr+2],DS     ; Must be set to print messages

; After this points the char device functions for CON will work for
; printing messages

	%IF	(! IBM) | (DEBUG)
	%IFN ALTVECT
HEADER equ Header	; NASM port label
	MOV	SI,OFFSET HEADER wrt DOSGROUP
OUTMES:
	call getdosdata
	mov ds, ax
	lodsb
	CMP	AL,"$"
	JZ	OUTDONE
	invalid function call
	invoke	OUT
	JMP	SHORT OUTMES
OUTDONE:
	PUSH	ds			; OUT stomps on segments
	POP	es
	%ENDIF
	%ENDIF

;F.C Modification start  DOS 3.3
	MOV	SI,OFFSET COUNTRY_CDPG wrt DOSGROUP  ;F.C. for DOS 3.3 country info
						 ; table address
	MOV	WORD PTR [ES:SI + ccUcase_ptr + 2],ES    ; initialize double word
	MOV	WORD PTR [ES:SI + ccFileUcase_ptr + 2],ES ; pointers with DOSGROUP
	MOV	WORD PTR [ES:SI + ccFileChar_ptr + 2],ES
	MOV	WORD PTR [ES:SI + ccCollate_ptr + 2],ES
ccMono_ptr equ ccMono_Ptr	; NASM port equate
	MOV	WORD PTR [ES:SI + ccMono_ptr + 2],ES	; => DOSDATA entrypoint into DOS
	MOV	WORD PTR [ES:SI + ccDBCS_ptr + 2],ES	; 2/16/KK

	MOV	SI,OFFSET SysInitTable wrt DOSGROUP
	MOV	WORD PTR [ES:SI + SYSI_Country_Tab + 2],ES
	MOV	WORD PTR [ES:SI + SYSI_InitVars + 2],ES

%ifdef BUF2
%else
BUFFHEAD equ BuffHead	; NASM port label
	MOV	WORD PTR [ES:BUFFHEAD+2],ES	  ;LB. DOS 4.00 buffer head pointer ;AN000;
	MOV	SI,OFFSET HASHINITVAR wrt DOSGROUP	  ;LB. points to Hashinitvar	   ;AN000;
	MOV	WORD PTR [ES:BUFFHEAD],SI	  ;LB.				   ;AN000;
	MOV	WORD PTR [ES:BUF_HASH_PTR+2],ES   ;LB.				   ;AN000;
	MOV	SI,OFFSET Hash_Temp wrt DOSGROUP	  ;LB.				   ;AN000;
	MOV	WORD PTR [ES:BUF_HASH_PTR],SI	  ;LB.				   ;AN000;
%endif

	MOV	word [ES:FETCHI_TAG],22642	  ; TAG for IBM,
					  ; Fetchi's serial # = 822642

	MOV	DI,OFFSET SWAP_START wrt DOSGROUP	  ;IFS. 			;AN000;
	MOV	CX,OFFSET SWAP_END wrt DOSGROUP	  ;IFS. 			;AN000;
Swap_Always equ SWAP_ALWAYS	; NASM port label
	MOV	DX,OFFSET Swap_Always wrt DOSGroup	  ;IFS. 			;AN000;
	MOV	BP,CX			;IFS.					;AN000;
	SUB	BP,DI			;IFS.					;AN000;
	SHR	BP,1			;IFS. div by 2, remainder in carry	;AN000;
	ADC	BP,0			;IFS. div by 2 + round up		;AN000;
	SHL	BP,1			;IFS. round up to 2 boundary.		;AN000;
	MOV	[ES:SWAP_AREA_LEN],BP	;IFS.					;AN000;

	SUB	CX,DX			;IFS.					;AN000;
	SUB	DX,DI			;IFS.					;AN000;
	SHR	CX,1			;IFS. div by 2, remainder in carry	;AN000;
	ADC	CX,0			;IFS. div by 2 + round up		;AN000;
	SHL	CX,1			;IFS. round up to 2 boundary.		;AN000;
	MOV	[ES:SWAP_IN_DOS_LEN],CX 	    ;IFS.			;AN000;
	MOV	WORD PTR [ES:SWAP_ALWAYS_AREA],DI   ;IFS.			;AN000;
	MOV	WORD PTR [ES:SWAP_ALWAYS_AREA+2],ES ;IFS.			;AN000;
	OR	DX,8000H			    ;IFS.			;AN000;
	MOV	[ES:SWAP_ALWAYS_AREA_LEN],DX	    ;IFS.			;AN000;
	MOV	DI,OFFSET Swap_Always wrt DOSGroup	    ;IFS.			;AN000;
	MOV	WORD PTR [ES:SWAP_IN_DOS],DI	    ;IFS.			;AN000;
	MOV	WORD PTR [ES:SWAP_IN_DOS+2],ES	    ;IFS.			;AN000;

SySInitTable equ SysInitTable	; NASM port label
	MOV	DI,OFFSET SySInitTable wrt DOSGROUP

	%IFN Installed
	invoke	NETWINIT
;	ELSE
;	invoke	NETWINIT
;	%OUT Random NETWINIT done at install
	%ENDIF

	mov ds, word [es:CurrentPDB]	; ds => created PSP
DMAADD equ DMAAdd	; NASM port label
	MOV	WORD PTR [es:DMAADD+2], ds
	retn


entry INITDPB
	call getdosdata
	mov es, ax

	lds si, [es:NULDEV]
CHAR_INIT_LOOP:
	LDS	SI,[SI]		; AUX device
	CALL	CHARINIT
	TEST	BYTE PTR [SI + SDEVATT],ISCLOCK
	JZ	CHAR_INIT_LOOP
BCLOCK equ BClock	; NASM port label
	MOV	WORD PTR [es:BCLOCK],SI
	MOV	WORD PTR [es:BCLOCK+2],DS

	mov ah, 48h
	mov bx, paras(DPBSIZ * 2)
	int 21h
	jnc @F
mem_err_j:
	extern MEM_ERR
	jmp MEM_ERR
@@:
	lframe
	lenter
	lvar word, dosdataseg
	 push es		; => DOS data segment
	lvar dword, nextdpb
	 push ax		; => DPB allocation
	xor ax, ax
	 push ax		; -> next DPB
PERDRIVER:
	mov es, word [bp + ?dosdataseg]
	LDS	SI,[SI]		; Next device
	CMP	SI,-1
	JZ	CONTINIT
	CALL	CHARINIT
	TEST	word [SI + SDEVATT],DEVTYP
	JNZ	PERDRIVER		; Skip any other character devs
CALLUNIT equ CallUnit	; NASM port label
	xor cx, cx
	MOV	CL,[es:CALLUNIT]
	MOV	[SI + SDEVNAME],CL	; Number of units in name field
	jcxz PERDRIVER
	PUSH	DS
	PUSH	SI
	MOV	DL,[es:NUMIO]
	XOR	DH,DH
	ADD	[es:NUMIO],CL
CALLBPB equ CallBPB	; NASM port label
	LDS	BX,[es:CALLBPB]
PERUNIT:
	MOV	SI,[BX] 		; DS:SI Points to BPB
	INC	BX
	INC	BX			; On to next BPB

	push bp
	les bp, [bp + ?nextdpb]

%if dpb_drive + 1 != dpb_UNIT
 %error Unexpected layout
%endif
	MOV	[ES:BP + dpb_drive], dx

	test bp, bp
	jz @F
	mov word [es:bp - DPBSIZ + dpb_next_dpb], bp
	mov word [es:bp - DPBSIZ + dpb_next_dpb + 2], es
@@:
	mov ax, -1
	mov word [es:bp + dpb_next_dpb], ax
	mov word [es:bp + dpb_next_dpb + 2], ax

	PUSH	BX
	PUSH	CX
	PUSH	DX

					; es => DPB allocation
	mov cl, 4
	lea bx, [bp + DPBSIZ + 15]	; -> behind this DPB, round up
	cmp bx, bp
	jb mem_err_j
	shr bx, cl			; to paragraphs
	mov ah, 4Ah
	int 21h				; resize
	jc mem_err_j

		; es:bp -> DPB, ds:si -> BPB
%if 0
	neartransfer	D_SETDPB
				; D_SETDPB works with ss != DOSDATA
%else
	mov ah, 53h
	int 21h
%endif
	MOV	AX,[ES:BP + dpb_sector_size]
	POP	DX
	POP	CX
	POP	BX

	pop bp
	mov es, word [bp + ?dosdataseg]

MAXSEC equ Maxsec	; NASM port label
	CMP	AX,[es:MAXSEC]
	JBE	NOTMAX
	MOV	[es:MAXSEC],AX
NOTMAX:


	MOV	AX,DS			; Save DS
	POP	SI
	POP	DS

	push bp
	les bp, [bp + ?nextdpb]

	MOV	WORD PTR [ES:BP + dpb_driver_addr],SI
	MOV	WORD PTR [ES:BP + dpb_driver_addr+2],DS

	pop bp

	PUSH	DS
	PUSH	SI
	INC	DH
	INC	DL
	MOV	DS,AX
	ADD	word [bp + ?nextdpb],DPBSIZ
	LOOP	PERUNIT
	POP	SI
	POP	DS
	JMP	PERDRIVER

dpb_smcb:
	db 0,0,0
	db "S",0		; name "S"
	db 8			; type S_DPB
	times 5 db 0

CONTINIT:		; es => DOSDATA
	pop ax			; offset last DPB
	pop ax			; => DPB allocation
	mov word [es:DPBHEAD + 2], ax
	dec ax
	mov es, ax
	mov word [es:arena_owner], 8
				; init owner
	mov di, arena_reserved
	 push cs
	 pop ds
	mov si, dpb_smcb
	mov cx, 3 + 8
	rep movsb		; init name and type

	pop ds			; => DOS data
	PUSH	ds
	POP	es
ASSUME	DS:DOSGROUP

	lleave

	JMP	MOVDPB

CHARINIT:
ASSUME	DS:NOTHING,ES:NOTHING
; DS:SI Points to device header
DEVCALL equ Devcall	; NASM port label
	PUSH	ES
	PUSH	BX
	PUSH	AX
	call getdosdata
	mov es, ax		; => DOSDATA
	pop ax
	push ax
	MOV	BX,OFFSET DEVCALL wrt DOSGROUP
	MOV	byte [es:bx + REQLEN],DINITHL
	MOV	byte [es:bx + REQUNIT],0
	MOV	byte [es:bx + REQFUNC],DEVINIT
	and	word [es:bx + REQSTAT],0
%if 0
	neartransfer	DEVIOCALL2
%else
		; device critical section is not yet enabled
	MOV	AX, [SI + SDEVSTRAT]
CALLDEVAD equ CallDevAd	; NASM port label
	MOV	WORD PTR [es:CALLDEVAD],AX
	MOV	WORD PTR [es:CALLDEVAD+2],DS
	CALL	far [es:CALLDEVAD]
	MOV	AX,[SI + SDEVINT]
	MOV	WORD PTR [es:CALLDEVAD],AX
	CALL	far [es:CALLDEVAD]
%endif
	POP	AX
	POP	BX
	POP	ES
	RET

%endif	; DOPLACEHOLDER

	align 16, nop
	global SYSSIZE
SYSSIZE LABEL	BYTE

section LAST

Public MSINI002S,MSINI002E
MSINI002S label byte

	align 2, db ?
	DW	?
	DB	"ADD SPECIAL ENTRIES",0     ;AN007  tiltle
;The following entries don't expect version 4.0
;The entry format: name_length, name, expected version, fake count
;fake_count: ff means the version will be reset when Abort or Exec is encountered
;	     n means the version will be reset after n DOS version calls are issued
;
Version_Fake_Table:			    ;AN007  starting address for special
	DB	12,"IBMCACHE.COM",3,40,255  ;AN007  ibmcache     1
	DB	12,"IBMCACHE.SYS",3,40,255  ;AN007  ibmcache     2
	DB	12,"DXMA0MOD.SYS",3,40,255  ;AN007  lan support  3
	DB	10,"WIN200.BIN"  ,3,40,4    ;AN008  windows      4
	DB	 9,"PSCPG.COM"   ,3,40,255  ;AN008  vittoria     5
	DB	11,"DCJSS02.EXE" ,3,40,255  ;AN008  netview      6
	DB	 8,"ISAM.EXE"    ,3,40,255  ;AN008  basic        7
	DB	 9,"ISAM2.EXE"   ,3,40,255  ;AN008  basic        8
	DB	12,"DFIA0MOD.SYS",3,40,255  ;AN008  lan support  9
	DB	20  dup(0)		    ;AN007

	align 16, db 0

MEMSTRT LABEL	WORD
MSINI002E label byte
ADJFAC	EQU	MEMSTRT-SYSBUF

%endif	; DONOBITS

; (no prior section) ; LAST	ENDS
